// #autoload
// #name = CokeFlagCall
// #version = 1.0
// #date = 12/2/2001 4:19PM
// #status = release
// #author = Coke
// #warrior = Coke
// #email = coke@ripnet.com
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = Scream for help after flag grab, along with custom grab/speed message. Optional flare message when you're out of flares, have the flag, and someone gets a missile lock.
// #include = support/team_tracker.cs
// #include = support/stat_support.cs
// #include = support/loadout.cs
// #category = CokeScripts
// #config = CokeFCConfig
// #credit = diogenes

package CokeFlagCall{

function CokeFCCheck (%clientid, %flagteam) {
	if (%clientid == teamTracker.myID) {
		$CokeFCGotFlag = true ;
		schedule($pref::CokeFC::Delay, 0, CokeFCSend);
	}
}
		
function CokeFCSend (%this) {
	if($CokeFCGotFlag){
		commandToServer( 'CannedChat', 'ChatHelp', false );
		if($pref::CokeFC::RepKitMessage){
			if(loadout.getRepairKit() > 0 ){
				%repkitpart = " with RepKit";
			}
			else{
				%repkitpart = " \c0without \c2RepKit";
			}
		}
				%speed = mFloor(getControlObjectSpeed() * 3.6);
				if (%speed < 76) {
					%saying = $pref::CokeFC::Message;
				} else if (%speed < 126) {
					%saying = $pref::CokeFC::Message2;
				} else if (%speed < 176) {
					%saying = $pref::CokeFC::Message3;
				} else {
					%saying = $pref::CokeFC::Message4;
				}
					
		%message = "\c2" @ %saying @ " " @ %speed @ "kph!" @ %repkitpart;
		commandToServer('TeamMessageSent', %message);
		}
}

function CokeFCDrop (%clientid, %flagteam){
	if (%clientid == teamTracker.myID) {
		$CokeFCGotFlag = false ;
	}
}

function GameConnection::onHomeWarning( %con, %state ){
	if( %state $= "true" ){   
		CokeFCFlare();
	}
	parent::onHomeWarning( %con, %state );
}
     	
function CokeFCFlare (%this){
	if($pref::CokeFC::FlareMessage){
		if($CokeFCGotFlag){
			%fav = $pref::Favorite[$pref::FavCurrentSelect];
			if(strstr( %fav, "Flare" ) >0){
				if(loadout.getGrenadeAmmo() < 1){
					%message = "** FLARE FOR ME I\'m out!! **~wneed.cover";
					commandToServer('TeamMessageSent', %message);
		      		}
		      	}
		}
	}
}

function CokeFCSetup (%this){
	if(!$pref::CokeFC::Delay){
		$pref::CokeFC::Delay = 4000;
	}
	
	if(!$pref::CokeFC::Message){
		$pref::CokeFC::Message = "Crawling home at";
	}
	if(!$pref::CokeFC::Message2){
	$pref::CokeFC::Message2 = "Coasting home at";
	}

	if(!$pref::CokeFC::Message3){
	$pref::CokeFC::Message3 = "Cruising home at";
	}

	if(!$pref::CokeFC::Message4){
	$pref::CokeFC::Message4 = "Im a Blur at";
	}	
	
	new GuiControl(CokeFCConfig) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellPaneCtrl() {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "251 392";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CokeFlagCall";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";

			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 29";
				extent = "211 340";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
			new ShellSliderCtrl(CokeFCDelaySlider) {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 50";
				extent = "186 24";
				minExtent = "12 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				altCommand = "CokeFCUpdatePrefs();";
				variable = "value";
				helpTag = "0";
				range = "0 10000";
				ticks = "11";
				value = "4000";
				usePlusMinus = "1";
			};
			new GuiTextCtrl(CokeFCDelayConfigText) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 35";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(CokeFCMessageConfigText) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 76";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0-75kph Message:";
			};
			new ShellTextEditCtrl(CokeFCMessage) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 89";
				extent = "209 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
				variable = "$pref::CokeFC::Message";
			};
//added
                        new GuiTextCtrl(CokeFCMessageConfigText2) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 120";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "76-125kph Message:";
			};
			new ShellTextEditCtrl(CokeFCMessage2) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 132";
				extent = "209 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
				variable = "$pref::CokeFC::Message2";
			};
                        new GuiTextCtrl(CokeFCMessageConfigText3) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 165";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "126-175kph Message:";
			};
			new ShellTextEditCtrl(CokeFCMessage3) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 175";
				extent = "209 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
				variable = "$pref::CokeFC::Message3";
			};
                        new GuiTextCtrl(CokeFCMessageConfigText4) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 210";
				extent = "109 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "175+kph Message:";
			};
			new ShellTextEditCtrl(CokeFCMessage4) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 218";
				extent = "209 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
				variable = "$pref::CokeFC::Message4";
			};
//end added
			new ShellToggleButton(CokeFCRepKitButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 250";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::CokeFC::RepKitMessage";
				helpTag = "0";
				text = "REPAIR KIT MESSAGE";
				maxLength = "255";
			};
			new ShellToggleButton(CokeFCFlareButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "46 270";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::CokeFC::FlareMessage";
				helpTag = "0";
				text = "FLARE MESSAGE";
				maxLength = "255";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "59 295";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "CokeFCUpdatePrefs();";
				helpTag = "0";
				text = "Apply CokeFlagCall Settings";
				simpleStyle = "0";
			};
			new GuiMLTextEditCtrl(CokeFCMessageDisplay) {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 325";
				extent = "200 30";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "CokeFlagCall Message:";
			};
		};
	};
	CokeFCMessage.setValue($pref::CokeFC::Message);
	CokeFCDelaySlider.setValue($pref::CokeFC::Delay);
	CokeFCRepKitButton.setValue($pref::CokeFC::RepKitMessage);
	CokeFCFlareButton.setValue($pref::CokeFC::FlareMessage);
	
	callback.add(onFlagGrab,CokeFCCheck);
	callback.add(onFlagDrop,CokeFCDrop);
}

function CokeFCConfig::OnWake(%this){
	CokeFCUpdatePrefs();
	parent::onwake(%this);
}

function CokeFCUpdatePrefs(%this){
	$pref::CokeFC::Delay = mFloor(CokeFCDelaySlider.getValue()/1000) * 1000;
	CokeFCDelayConfigText.setValue("CokeFlagCall - " @ mFloor(CokeFCDelaySlider.getValue()/1000) @ " seconds after flag grab");

	$pref::CokeFC::Message = CokeFCMessage.getValue();
	if($pref::CokeFC::RepKitMessage){
			if(loadout.getRepairKit() > 0 ){
				%repkitpart = " with RepKit";
			}
			else{
				%repkitpart = " \c0without \c2RepKit";
			}
	}				
	%message = $pref::CokeFC::Message @ " 75kph " @ %repkitpart;
	CokeFCMessageDisplay.setvalue(%message);
}

};
 
activatePackage(CokeFlagCall);

CokeFCSetup();



		
